/*
 Name:		Encoder.cpp
 Created:	06.10.2018 16:33:46
 Author:	Felix Bruchhage und Luca Di Lillo
 Version: 1.0.1
*/

#include "Encoder.h"

Encoder::Encoder(void)
{

}

Encoder::~Encoder()
{

}
/******************************************
*This initializes the Encoder library.	  *
*The first input argument is for signal A,* 
*the second argument is for signal B	  *
******************************************/
void Encoder::begin(int PORT_A, int PORT_B)
{
	SIG_A = PORT_A;
	SIG_B = PORT_B;

	pinMode(SIG_A, INPUT);
	pinMode(SIG_B, INPUT);
}

/******************************************
*This function shows the actual direction *
*of the encoder							  *
******************************************/
char Encoder::getDirection()
{

	if (digitalRead(SIG_A) == HIGH && A_HIGH_direction == false && A_LOW_direction == true)
	{
		zeit_A_HIGH_direction = millis();
		A_HIGH_direction = true;
		A_LOW_direction = false;

	}
	if (digitalRead(SIG_A) == LOW && A_HIGH_direction == true && A_LOW_direction == false)
	{
		zeit_A_LOW_direction = millis();
		A_HIGH_direction = false;
		A_LOW_direction = true;
	}



	if (digitalRead(SIG_B) == HIGH && B_HIGH_direction == false && B_LOW_direction == true)
	{
		zeit_B_HIGH_direction = millis();
		B_HIGH_direction = true;
		B_LOW_direction = false;
	}

	if (digitalRead(SIG_B) == LOW && B_HIGH_direction == true && B_LOW_direction == false)
	{
		zeit_B_LOW_direction = millis();
		B_HIGH_direction = false;
		B_LOW_direction = true;
	}

	if (zeit_A_LOW_direction < zeit_B_LOW_direction && zeit_A_HIGH_direction < zeit_B_HIGH_direction)
	{
		zeit_A_LOW_direction = 0;
		zeit_B_LOW_direction = 0;

		zeit_A_HIGH_direction = 0;
		zeit_B_HIGH_direction = 0;

		direction = 'l';		
	}

	if (zeit_A_LOW_direction > zeit_B_LOW_direction && zeit_A_HIGH_direction > zeit_B_HIGH_direction)
	{
		zeit_A_LOW_direction = 0;
		zeit_B_LOW_direction = 0;

		zeit_A_HIGH_direction = 0;
		zeit_B_HIGH_direction = 0;

		direction = 'r';
	}


	return direction;
}

/******************************************
*This function shows the actual position  *
*of the encoder							  *
******************************************/
int Encoder::getPosition()
{
	if (digitalRead(SIG_A) == HIGH && A_HIGH == false && A_LOW == true)
	{
		zeit_A_HIGH = millis();
		A_HIGH = true;
		A_LOW = false;
		
	}
	if (digitalRead(SIG_A) == LOW && A_HIGH == true && A_LOW == false)
	{
		zeit_A_LOW = millis();
		A_HIGH = false;
		A_LOW = true;
	}



	if (digitalRead(SIG_B) == HIGH && B_HIGH == false && B_LOW == true)
	{
		zeit_B_HIGH = millis();
		B_HIGH = true;
		B_LOW = false;
	}

	if (digitalRead(SIG_B) == LOW && B_HIGH == true && B_LOW == false)
	{
		zeit_B_LOW = millis();
		B_HIGH = false;
		B_LOW = true;
	}

	if (zeit_A_LOW < zeit_B_LOW && zeit_A_HIGH < zeit_B_HIGH)
	{
		zeit_A_LOW = 0;
		zeit_B_LOW = 0;

		zeit_A_HIGH = 0;
		zeit_B_HIGH = 0;

		direction = 'l';

		position--;
	}

	if (zeit_A_LOW > zeit_B_LOW && zeit_A_HIGH > zeit_B_HIGH)
	{
		zeit_A_LOW = 0;
		zeit_B_LOW = 0;

		zeit_A_HIGH = 0;
		zeit_B_HIGH = 0;

		direction = 'r';

		position++;
	}

	return position;
}

/******************************************
*This function clears the actual position * 
*of the encoder						      *
******************************************/
void Encoder::clearPosition()
{
	position = 0;
}

void Encoder::setPosition(int Position)
{
	position = Position;
}

