/*
 Name:		Encoder.h
 Created:	06.10.2018 16:33:46
 Author:	Felix Bruchhage und Luca Di Lillo
 Version:	1.0.1
*/

#ifndef _Encoder_h
#define _Encoder_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif


#endif

class Encoder
{
public:
	Encoder(void);
	~Encoder(void);
	void begin(int PORT_A, int PORT_B);
	char getDirection();
	int getPosition();
	void clearPosition();
	void setPosition(int Position);

private:
	int position;
	int SIG_A;
	int SIG_B;

	//Variablen fr Position
	double zeit_A_HIGH = 0;
	double zeit_A_LOW = 0;

	double zeit_B_HIGH = 0;
	double zeit_B_LOW = 0;

	bool A_HIGH = false;
	bool A_LOW = true;

	bool B_HIGH = false;
	bool B_LOW = true;


	//Variablen fr Drehrichtung
	char direction = ' ';
	double zeit_A_HIGH_direction = 0;
	double zeit_A_LOW_direction = 0;

	double zeit_B_HIGH_direction = 0;
	double zeit_B_LOW_direction = 0;

	bool A_HIGH_direction = false;
	bool A_LOW_direction = true;

	bool B_HIGH_direction = false;
	bool B_LOW_direction = true;
};

